#include <stdio.h>
#include <string.h>
#ifdef __TURBOC__
	#include <dir.h>
#else
	#ifdef __POWERC__
		#include <dir.h>
	#else
		#ifdef M_I86
			#include <direct.h>
		#endif
	#endif
#endif
#include <dos.h>

#include "queue.h"
#include "ufind.h"

/**************************************************************************
 * EnsureExists - Ensure that a given pathname exists.  If any directory
 *	 			  in the path does NOT exist, EnsureExists will create it
 *				  with no warning.
 *************************************************************************/
void
EnsureExists (char *Path) {
	char *Ptr;
	int i;
	struct DIR_BLK DirBlk;


	if (!FIND_FIRST(Path, &DirBlk, DIREC_)
		&& (DirBlk.DIR_ATTR & DIREC_) != 0) return;
	Ptr = Path;
	while ( (i = strcspn(Ptr, "/\\")), Ptr[i] != '\0') {
		if ( (Ptr != Path) || (i >= 3) ) {
			Ptr[i] = '\0';
			EnsureExists(Path);
			Ptr[i] = '\\';
			}
		Ptr += ++i;
		}
	mkdir(Path);
	}


