#define VERSION "4.0.2"
#define VERSION_DATE "November 3, 1989"

#ifdef __TURBOC__
	#define ARCH      FA_ARCH
	#define DIREC_    FA_DIREC
	#define LABEL_    FA_LABEL
	#define SYSTEM_   FA_SYSTEM
	#define HIDDEN_   FA_HIDDEN
	#define RDONLY_   FA_RDONLY
	#define DIR_BLK   ffblk
	#define DIR_ATTR  ff_attrib
	#define DIR_TIME  ff_ftime
	#define DIR_DATE  ff_fdate
	#define DIR_FSIZE ff_fsize
	#define DIR_FNAME ff_name
	#define FIND_FIRST(p,b,a) findfirst((p),(b),(a))
	#define FIND_NEXT findnext
#else
	#ifdef __POWERC__
		#define ARCH      FA_ARCH
		#define DIREC_    FA_DIREC
		#define LABEL_    FA_LABEL
		#define SYSTEM_   FA_SYSTEM
		#define HIDDEN_   FA_HIDDEN
		#define RDONLY_   FA_RDONLY
		#define DIR_BLK   ffblk
		#define DIR_ATTR  ff_attrib
		#define DIR_TIME  ff_ftime
		#define DIR_DATE  ff_fdate
		#define DIR_FSIZE ff_fsize
		#define DIR_FNAME ff_name
		#define FIND_FIRST(p,b,a) findfirst((p),(b),(a))
		#define FIND_NEXT findnext
	#else
		#ifdef M_I86
			#define ARCH      _A_ARCH
			#define DIREC_    _A_SUBDIR
			#define LABEL_    _A_VOLID
			#define SYSTEM_   _A_SYSTEM
			#define HIDDEN_   _A_HIDDEN
			#define RDONLY_   _A_RDONLY
			#define DIR_BLK   find_t
			#define DIR_ATTR  attrib
			#define DIR_TIME  wr_time
			#define DIR_DATE  wr_date
			#define DIR_FSIZE size
			#define DIR_FNAME name
			#define FIND_FIRST(p,b,a) _dos_findfirst((p),(a),(b))
			#define FIND_NEXT _dos_findnext
		#endif
	#endif
#endif

#define TRUE	1
#define FALSE	0
#define IsDir(x)	((x) & DIREC_)

#ifdef MAIN
	#define EXTERN
	#define INIT(x) = x
#else
	#define EXTERN extern
	#define INIT(x)
#endif

EXTERN union {
	unsigned Date;
	struct {
		unsigned day:   5;
		unsigned month: 4;
		unsigned year:  7;
		} d;
	} FDate;

EXTERN union {
	unsigned time;
	struct {
		unsigned sec:  5;
		unsigned minute:  6;
		unsigned hour: 5;
		} t;
	} FileTime;

EXTERN char SwitChar;

EXTERN QUE_DEF PNames;
EXTERN QUE_ENTRY *Ptr;

EXTERN int  BaseLength;

/* matches parameters */

EXTERN char *IncNames[20];
EXTERN int  IncNamesCnt    INIT(0);
EXTERN char *ExcNames[20];
EXTERN int  ExcNamesCnt     INIT(0);
EXTERN char *IncFNames[20];
EXTERN int  CntIncFNames   INIT(0);
EXTERN char *ExcFNames[20];
EXTERN int  CntExcFNames    INIT(0);
EXTERN char  IsAttrOn       INIT(0);
EXTERN char  IsAttrOff      INIT(0);
EXTERN int  NrFlag         INIT(FALSE);
EXTERN int  ExistsFlag     INIT(FALSE);
EXTERN int  NewSwt		   INIT(FALSE);
EXTERN char *ExistsName;
EXTERN int  MatchDotFlag   INIT(FALSE);
EXTERN int  MatchSlashFlag INIT(FALSE);
EXTERN int  SizeFlag       INIT(FALSE);
EXTERN long SizeSize;

EXTERN enum DateSequence {
			none,
			LT, LE, GT, GE,
			LTDATE, LEDATE, GTDATE, GEDATE,
			SI, BE, SIBE
			} DtStyle;

EXTERN int      DtDir;
EXTERN unsigned DtTime, DtDate;
EXTERN char     *DtName;

EXTERN unsigned Today;
EXTERN unsigned SiDate INIT(0);		/* "Since" Date  */
EXTERN unsigned SiTime INIT(0);		/* "Since" Time  */
EXTERN unsigned BeDate INIT(0);		/* "Before" Date */
EXTERN unsigned BeTime INIT(0);		/* "Before" Time */

/* action parameters */

EXTERN int PrintFlag  INIT(FALSE);
EXTERN int QuietFlag  INIT(FALSE);
EXTERN int LsFlag     INIT(FALSE);
EXTERN int LdFlag     INIT(FALSE);
EXTERN char NFlag     INIT(FALSE);
EXTERN int PromptFlag INIT(FALSE);
EXTERN int TFlag      INIT(FALSE);
EXTERN int WarnFlag   INIT(FALSE);
EXTERN int CpFlag     INIT(FALSE);
EXTERN int MvFlag     INIT(FALSE);
EXTERN int BackupFlag INIT(FALSE);
EXTERN int RmFlag     INIT(FALSE);
EXTERN int RmDirFlag  INIT(FALSE);
EXTERN int SumFlag    INIT(FALSE);
EXTERN int CompFlag   INIT(FALSE);
EXTERN int ExecFlag   INIT(FALSE);
EXTERN int NewFlag    INIT(FALSE);

EXTERN int  AttrOff INIT(0);
EXTERN int  AttrOn  INIT(0);
EXTERN long SumSize;
EXTERN char ToDir[64];
EXTERN char CurDir[64];
EXTERN char CompDir[64];
EXTERN char CommandString[128] INIT("");
unsigned SysDate (void);
void     GetArgs (char ***argv);
unsigned GetDateArg (char *Str);
void     FixDirectory (char *Src, char *Dest);
void     Error (char *Format, ...);
int      CompareDates(int ADate, int BDate, int ATime, int BTime);
char     *OtherName(char *BaseName, char *ToDir);
int      Matches (char *BaseName, struct DIR_BLK *FF);
int      YesNo (char *Format, ...);
void     PerformAction(char *BaseName, struct DIR_BLK *FF);
void     FindFiles(char *BaseName);
int      ParseAttributes(char *Attributes);

/* Prototypes for other source files */
/*                                   */
/*  -From amatch.c                   */

int AMatch(char *Str, char *Pat);

int RootPath(char *RelativePath, char *FullPath);

void EnsureExists (char *Path);